package dev.shadowsoffire.apotheosis.adventure.socket;

import net.minecraft.world.item.crafting.Recipe;
import net.minecraft.network.FriendlyByteBuf;
import com.google.gson.JsonObject;
import net.minecraft.world.item.crafting.RecipeType;
import net.minecraft.world.item.crafting.RecipeSerializer;
import dev.shadowsoffire.placebo.reload.DynamicHolder;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import net.minecraft.network.chat.Style;
import net.minecraft.network.chat.Component;
import dev.shadowsoffire.apotheosis.adventure.affix.AffixHelper;
import net.minecraft.core.RegistryAccess;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.world.level.Level;
import net.minecraft.world.Container;
import net.minecraft.world.item.ItemStack;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.resources.ResourceLocation;
import dev.shadowsoffire.apotheosis.adventure.AdventureModule;

public class UnnamingRecipe extends AdventureModule.ApothSmithingRecipe
{
    private static final ResourceLocation ID;
    
    public UnnamingRecipe() {
        super(UnnamingRecipe.ID, Ingredient.f_43901_, Ingredient.m_43929_(new ItemLike[] { (ItemLike)Adventure.Items.SIGIL_OF_UNNAMING.get() }), ItemStack.f_41583_);
    }
    
    public boolean m_5818_(final Container pInv, final Level pLevel) {
        final ItemStack base = pInv.m_8020_(1);
        if (base.m_41619_()) {
            return false;
        }
        final CompoundTag afxData = base.m_41737_("affix_data");
        final boolean hasName = afxData != null && afxData.m_128425_("name", 8);
        return hasName && pInv.m_8020_(2).m_41720_() == Adventure.Items.SIGIL_OF_UNNAMING.get();
    }
    
    public ItemStack m_5874_(final Container pInv, final RegistryAccess regs) {
        final ItemStack out = pInv.m_8020_(1).m_41777_();
        final CompoundTag afxData = out.m_41737_("affix_data");
        final DynamicHolder<LootRarity> rarity = (DynamicHolder<LootRarity>)AffixHelper.getRarity(afxData);
        if (afxData == null || !rarity.isBound()) {
            return ItemStack.f_41583_;
        }
        final Component comp = (Component)Component.m_237110_("%2$s", new Object[] { "", "" }).m_130948_(Style.f_131099_.m_131148_(((LootRarity)rarity.get()).getColor()));
        AffixHelper.setName(out, comp);
        return out;
    }
    
    public RecipeSerializer<?> m_7707_() {
        return (RecipeSerializer<?>)Serializer.INSTANCE;
    }
    
    public RecipeType<?> m_6671_() {
        return (RecipeType<?>)RecipeType.f_44113_;
    }
    
    public boolean m_5598_() {
        return true;
    }
    
    static {
        ID = new ResourceLocation("apotheosis:unnaming");
    }
    
    public static class Serializer implements RecipeSerializer<UnnamingRecipe>
    {
        public static Serializer INSTANCE;
        
        public UnnamingRecipe fromJson(final ResourceLocation pRecipeId, final JsonObject pJson) {
            return new UnnamingRecipe();
        }
        
        public UnnamingRecipe fromNetwork(final ResourceLocation pRecipeId, final FriendlyByteBuf pBuffer) {
            return new UnnamingRecipe();
        }
        
        public void toNetwork(final FriendlyByteBuf pBuffer, final UnnamingRecipe pRecipe) {
        }
        
        static {
            Serializer.INSTANCE = new Serializer();
        }
    }
}
